#!/usr/bin/env python
# coding: utf-8

# ![image.png](attachment:image.png)

# In[26]:


# Carregando as bibliotecas

import pandas as pd
import numpy as np
import yfinance as yf
from plotly.subplots import make_subplots
import plotly.graph_objects as go

get_ipython().run_line_magic("matplotlib", "inline")
import warnings
warnings.filterwarnings("ignore")


# In[27]:


# Carregando a base de dados e fazendo os checks iniciais

# Carrega as bases
ticker1 = "USIM5.SA" 
df1 = yf.download(ticker1, "2012-01-01", "2022-12-31")
df1["Retornos"] = df1["Adj Close"].pct_change(1)


# In[28]:


df1.head()


# In[29]:


df1_12 = df1["2012"]
df1_13 = df1["2013"]
df1_14 = df1["2014"]
df1_15 = df1["2015"]
df1_16 = df1["2016"]
df1_17 = df1["2017"]
df1_18 = df1["2018"]
df1_19 = df1["2019"]
df1_20 = df1["2020"]
df1_21 = df1["2021"]
df1_22 = df1["2022"]


# In[30]:


df1_12.iloc[0, :]


# In[31]:


df1_12["Normalizado"]=100*(df1_12 / df1_12.iloc[0, :])["Adj Close"]
df1_13["Normalizado"]=100*(df1_13 / df1_13.iloc[0, :])["Adj Close"]
df1_14["Normalizado"]=100*(df1_14 / df1_14.iloc[0, :])["Adj Close"]
df1_15["Normalizado"]=100*(df1_15 / df1_15.iloc[0, :])["Adj Close"]
df1_16["Normalizado"]=100*(df1_16 / df1_16.iloc[0, :])["Adj Close"]
df1_17["Normalizado"]=100*(df1_17 / df1_17.iloc[0, :])["Adj Close"]
df1_18["Normalizado"]=100*(df1_18 / df1_18.iloc[0, :])["Adj Close"]
df1_19["Normalizado"]=100*(df1_19 / df1_19.iloc[0, :])["Adj Close"]
df1_20["Normalizado"]=100*(df1_20 / df1_20.iloc[0, :])["Adj Close"]
df1_21["Normalizado"]=100*(df1_21 / df1_21.iloc[0, :])["Adj Close"]
df1_22["Normalizado"]=100*(df1_22 / df1_22.iloc[0, :])["Adj Close"]


# In[32]:


df1_12.head()


# In[33]:


# Gráfico

fig = make_subplots(rows = 1, cols = 1,
                    shared_xaxes = True,
                    vertical_spacing = 0.08)

fig.add_trace(go.Scatter(x = df1_12.index, y = df1_12["Normalizado"]
                         , name = "2012", line = dict(color = "blue"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df1_12.index, y = df1_13["Normalizado"]
                         , name = "2013", line = dict(color = "Red"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df1_12.index, y = df1_14["Normalizado"]
                         , name = "2014", line = dict(color = "Orange"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df1_12.index, y = df1_15["Normalizado"]
                         , name = "2015", line = dict(color = "Purple"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df1_12.index, y = df1_16["Normalizado"]
                         , name = "2016", line = dict(color = "Black"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df1_12.index, y = df1_17["Normalizado"]
                         , name = "2017", line = dict(color = "Green"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df1_12.index, y = df1_18["Normalizado"]
                         , name = "2018", line = dict(color = "Red"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df1_12.index, y = df1_19["Normalizado"]
                         , name = "2019", line = dict(color = "Gray"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df1_12.index, y = df1_20["Normalizado"]
                         , name = "2020", line = dict(color = "Dark Blue"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df1_12.index, y = df1_21["Normalizado"]
                         , name = "2021", line = dict(color = "Dark Green"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df1_12.index, y = df1_22["Normalizado"]
                         , name = "2022", line = dict(color = "Dark Gray"))
              , row = 1, col = 1)


fig.update_layout(height = 600, width = 600
                  , title_text = "Performance Anual " + ticker1
                  , font_color = "blue"
                  , title_font_color = "black"
                  , xaxis_title = "Meses"
                  , xaxis = dict(tickformat="%m")
                  , yaxis_title = "Fechamento Normalizado"
                  , legend_title = "Anos"
                  , font = dict(size = 15, color = "Black")
                 )
fig.update_layout(hovermode = "x")

fig.show()


# In[34]:


#df11T

df11T_12 = df1[df1.index.month.isin([1,2,3])]["2012"]
df11T_13 = df1[df1.index.month.isin([1,2,3])]["2013"]
df11T_14 = df1[df1.index.month.isin([1,2,3])]["2014"]
df11T_15 = df1[df1.index.month.isin([1,2,3])]["2015"]
df11T_16 = df1[df1.index.month.isin([1,2,3])]["2016"]
df11T_17 = df1[df1.index.month.isin([1,2,3])]["2017"]
df11T_18 = df1[df1.index.month.isin([1,2,3])]["2018"]
df11T_19 = df1[df1.index.month.isin([1,2,3])]["2019"]
df11T_20 = df1[df1.index.month.isin([1,2,3])]["2020"]
df11T_21 = df1[df1.index.month.isin([1,2,3])]["2021"]
df11T_22 = df1[df1.index.month.isin([1,2,3])]["2022"]

df11T_12["Normalizado"]=100*(df11T_12 / df11T_12.iloc[0, :])["Adj Close"]
df11T_13["Normalizado"]=100*(df11T_13 / df11T_13.iloc[0, :])["Adj Close"]
df11T_14["Normalizado"]=100*(df11T_14 / df11T_14.iloc[0, :])["Adj Close"]
df11T_15["Normalizado"]=100*(df11T_15 / df11T_15.iloc[0, :])["Adj Close"]
df11T_16["Normalizado"]=100*(df11T_16 / df11T_16.iloc[0, :])["Adj Close"]
df11T_17["Normalizado"]=100*(df11T_17 / df11T_17.iloc[0, :])["Adj Close"]
df11T_18["Normalizado"]=100*(df11T_18 / df11T_18.iloc[0, :])["Adj Close"]
df11T_19["Normalizado"]=100*(df11T_19 / df11T_19.iloc[0, :])["Adj Close"]
df11T_20["Normalizado"]=100*(df11T_20 / df11T_20.iloc[0, :])["Adj Close"]
df11T_21["Normalizado"]=100*(df11T_21 / df11T_21.iloc[0, :])["Adj Close"]
df11T_22["Normalizado"]=100*(df11T_22 / df11T_22.iloc[0, :])["Adj Close"]

# Gráfico 1T

fig = make_subplots(rows = 1, cols = 1,
                    shared_xaxes = True,
                    vertical_spacing = 0.08)

fig.add_trace(go.Scatter(x = df11T_12.index, y = df11T_12["Normalizado"]
                         , name = "2012", line = dict(color = "blue"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df11T_12.index, y = df11T_13["Normalizado"]
                         , name = "2013", line = dict(color = "Red"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df11T_12.index, y = df11T_14["Normalizado"]
                         , name = "2014", line = dict(color = "Orange"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df11T_12.index, y = df11T_15["Normalizado"]
                         , name = "2015", line = dict(color = "Purple"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df11T_12.index, y = df11T_16["Normalizado"]
                         , name = "2016", line = dict(color = "Black"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df11T_12.index, y = df11T_17["Normalizado"]
                         , name = "2017", line = dict(color = "Green"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df11T_12.index, y = df11T_18["Normalizado"]
                         , name = "2018", line = dict(color = "Red"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df11T_12.index, y = df11T_19["Normalizado"]
                         , name = "2019", line = dict(color = "Gray"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df11T_12.index, y = df11T_20["Normalizado"]
                         , name = "2020", line = dict(color = "Dark Blue"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df11T_12.index, y = df11T_21["Normalizado"]
                         , name = "2021", line = dict(color = "Dark Green"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df11T_12.index, y = df11T_22["Normalizado"]
                         , name = "2022", line = dict(color = "Dark Gray"))
              , row = 1, col = 1)


fig.update_layout(height = 600, width = 600
                  , title_text = "Performance Anual 1T " + ticker1
                  , font_color = "blue"
                  , title_font_color = "black"
                  , xaxis_title = "Meses"
                  , xaxis = dict(tickformat="%m")
                  , yaxis_title = "Fechamento Normalizado"
                  , legend_title = "Anos"
                  , font = dict(size = 15, color = "Black")
                 )
fig.update_layout(hovermode = "x")

fig.show()


# In[35]:


#df12T

df12T_12 = df1[df1.index.month.isin([4,5,6])]["2012"]
df12T_13 = df1[df1.index.month.isin([4,5,6])]["2013"]
df12T_14 = df1[df1.index.month.isin([4,5,6])]["2014"]
df12T_15 = df1[df1.index.month.isin([4,5,6])]["2015"]
df12T_16 = df1[df1.index.month.isin([4,5,6])]["2016"]
df12T_17 = df1[df1.index.month.isin([4,5,6])]["2017"]
df12T_18 = df1[df1.index.month.isin([4,5,6])]["2018"]
df12T_19 = df1[df1.index.month.isin([4,5,6])]["2019"]
df12T_20 = df1[df1.index.month.isin([4,5,6])]["2020"]
df12T_21 = df1[df1.index.month.isin([4,5,6])]["2021"]
df12T_22 = df1[df1.index.month.isin([4,5,6])]["2022"]

df12T_12["Normalizado"]=100*(df12T_12 / df12T_12.iloc[0, :])["Adj Close"]
df12T_13["Normalizado"]=100*(df12T_13 / df12T_13.iloc[0, :])["Adj Close"]
df12T_14["Normalizado"]=100*(df12T_14 / df12T_14.iloc[0, :])["Adj Close"]
df12T_15["Normalizado"]=100*(df12T_15 / df12T_15.iloc[0, :])["Adj Close"]
df12T_16["Normalizado"]=100*(df12T_16 / df12T_16.iloc[0, :])["Adj Close"]
df12T_17["Normalizado"]=100*(df12T_17 / df12T_17.iloc[0, :])["Adj Close"]
df12T_18["Normalizado"]=100*(df12T_18 / df12T_18.iloc[0, :])["Adj Close"]
df12T_19["Normalizado"]=100*(df12T_19 / df12T_19.iloc[0, :])["Adj Close"]
df12T_20["Normalizado"]=100*(df12T_20 / df12T_20.iloc[0, :])["Adj Close"]
df12T_21["Normalizado"]=100*(df12T_21 / df12T_21.iloc[0, :])["Adj Close"]
df12T_22["Normalizado"]=100*(df12T_22 / df12T_22.iloc[0, :])["Adj Close"]

# Gráfico 2T

fig = make_subplots(rows = 1, cols = 1,
                    shared_xaxes = True,
                    vertical_spacing = 0.08)

fig.add_trace(go.Scatter(x = df12T_12.index, y = df12T_12["Normalizado"]
                         , name = "2012", line = dict(color = "blue"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df12T_12.index, y = df12T_13["Normalizado"]
                         , name = "2013", line = dict(color = "Red"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df12T_12.index, y = df12T_14["Normalizado"]
                         , name = "2014", line = dict(color = "Orange"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df12T_12.index, y = df12T_15["Normalizado"]
                         , name = "2015", line = dict(color = "Purple"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df12T_12.index, y = df12T_16["Normalizado"]
                         , name = "2016", line = dict(color = "Black"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df12T_12.index, y = df12T_17["Normalizado"]
                         , name = "2017", line = dict(color = "Green"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df12T_12.index, y = df12T_18["Normalizado"]
                         , name = "2018", line = dict(color = "Red"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df12T_12.index, y = df12T_19["Normalizado"]
                         , name = "2019", line = dict(color = "Gray"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df12T_12.index, y = df12T_20["Normalizado"]
                         , name = "2020", line = dict(color = "Dark Blue"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df12T_12.index, y = df12T_21["Normalizado"]
                         , name = "2021", line = dict(color = "Dark Green"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df12T_12.index, y = df12T_22["Normalizado"]
                         , name = "2022", line = dict(color = "Dark Gray"))
              , row = 1, col = 1)


fig.update_layout(height = 600, width = 600
                  , title_text = "Performance Anual 2T " + ticker1
                  , font_color = "blue"
                  , title_font_color = "black"
                  , xaxis_title = "Meses"
                  , xaxis = dict(tickformat="%m")
                  , yaxis_title = "Fechamento Normalizado"
                  , legend_title = "Anos"
                  , font = dict(size = 15, color = "Black")
                 )
fig.update_layout(hovermode = "x")

fig.show()


# In[36]:


#df13T

df13T_12 = df1[df1.index.month.isin([7,8,9])]["2012"]
df13T_13 = df1[df1.index.month.isin([7,8,9])]["2013"]
df13T_14 = df1[df1.index.month.isin([7,8,9])]["2014"]
df13T_15 = df1[df1.index.month.isin([7,8,9])]["2015"]
df13T_16 = df1[df1.index.month.isin([7,8,9])]["2016"]
df13T_17 = df1[df1.index.month.isin([7,8,9])]["2017"]
df13T_18 = df1[df1.index.month.isin([7,8,9])]["2018"]
df13T_19 = df1[df1.index.month.isin([7,8,9])]["2019"]
df13T_20 = df1[df1.index.month.isin([7,8,9])]["2020"]
df13T_21 = df1[df1.index.month.isin([7,8,9])]["2021"]
df13T_22 = df1[df1.index.month.isin([7,8,9])]["2022"]

df13T_12["Normalizado"]=100*(df13T_12 / df13T_12.iloc[0, :])["Adj Close"]
df13T_13["Normalizado"]=100*(df13T_13 / df13T_13.iloc[0, :])["Adj Close"]
df13T_14["Normalizado"]=100*(df13T_14 / df13T_14.iloc[0, :])["Adj Close"]
df13T_15["Normalizado"]=100*(df13T_15 / df13T_15.iloc[0, :])["Adj Close"]
df13T_16["Normalizado"]=100*(df13T_16 / df13T_16.iloc[0, :])["Adj Close"]
df13T_17["Normalizado"]=100*(df13T_17 / df13T_17.iloc[0, :])["Adj Close"]
df13T_18["Normalizado"]=100*(df13T_18 / df13T_18.iloc[0, :])["Adj Close"]
df13T_19["Normalizado"]=100*(df13T_19 / df13T_19.iloc[0, :])["Adj Close"]
df13T_20["Normalizado"]=100*(df13T_20 / df13T_20.iloc[0, :])["Adj Close"]
df13T_21["Normalizado"]=100*(df13T_21 / df13T_21.iloc[0, :])["Adj Close"]
df13T_22["Normalizado"]=100*(df13T_22 / df13T_22.iloc[0, :])["Adj Close"]

# Gráfico 3T

fig = make_subplots(rows = 1, cols = 1,
                    shared_xaxes = True,
                    vertical_spacing = 0.08)

fig.add_trace(go.Scatter(x = df13T_12.index, y = df13T_12["Normalizado"]
                         , name = "2012", line = dict(color = "blue"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df13T_12.index, y = df13T_13["Normalizado"]
                         , name = "2013", line = dict(color = "Red"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df13T_12.index, y = df13T_14["Normalizado"]
                         , name = "2014", line = dict(color = "Orange"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df13T_12.index, y = df13T_15["Normalizado"]
                         , name = "2015", line = dict(color = "Purple"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df13T_12.index, y = df13T_16["Normalizado"]
                         , name = "2016", line = dict(color = "Black"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df13T_12.index, y = df13T_17["Normalizado"]
                         , name = "2017", line = dict(color = "Green"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df13T_12.index, y = df13T_18["Normalizado"]
                         , name = "2018", line = dict(color = "Red"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df13T_12.index, y = df13T_19["Normalizado"]
                         , name = "2019", line = dict(color = "Gray"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df13T_12.index, y = df13T_20["Normalizado"]
                         , name = "2020", line = dict(color = "Dark Blue"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df13T_12.index, y = df13T_21["Normalizado"]
                         , name = "2021", line = dict(color = "Dark Green"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df13T_12.index, y = df13T_22["Normalizado"]
                         , name = "2022", line = dict(color = "Dark Gray"))
              , row = 1, col = 1)


fig.update_layout(height = 600, width = 600
                  , title_text = "Performance Anual 3T " + ticker1
                  , font_color = "blue"
                  , title_font_color = "black"
                  , xaxis_title = "Meses"
                  , xaxis = dict(tickformat="%m")
                  , yaxis_title = "Fechamento Normalizado"
                  , legend_title = "Anos"
                  , font = dict(size = 15, color = "Black")
                 )
fig.update_layout(hovermode = "x")

fig.show()


# In[37]:


#df14T

df14T_12 = df1[df1.index.month.isin([10,11,12])]["2012"]
df14T_13 = df1[df1.index.month.isin([10,11,12])]["2013"]
df14T_14 = df1[df1.index.month.isin([10,11,12])]["2014"]
df14T_15 = df1[df1.index.month.isin([10,11,12])]["2015"]
df14T_16 = df1[df1.index.month.isin([10,11,12])]["2016"]
df14T_17 = df1[df1.index.month.isin([10,11,12])]["2017"]
df14T_18 = df1[df1.index.month.isin([10,11,12])]["2018"]
df14T_19 = df1[df1.index.month.isin([10,11,12])]["2019"]
df14T_20 = df1[df1.index.month.isin([10,11,12])]["2020"]
df14T_21 = df1[df1.index.month.isin([10,11,12])]["2021"]
df14T_22 = df1[df1.index.month.isin([10,11,12])]["2022"]

df14T_12["Normalizado"]=100*(df14T_12 / df14T_12.iloc[0, :])["Adj Close"]
df14T_13["Normalizado"]=100*(df14T_13 / df14T_13.iloc[0, :])["Adj Close"]
df14T_14["Normalizado"]=100*(df14T_14 / df14T_14.iloc[0, :])["Adj Close"]
df14T_15["Normalizado"]=100*(df14T_15 / df14T_15.iloc[0, :])["Adj Close"]
df14T_16["Normalizado"]=100*(df14T_16 / df14T_16.iloc[0, :])["Adj Close"]
df14T_17["Normalizado"]=100*(df14T_17 / df14T_17.iloc[0, :])["Adj Close"]
df14T_18["Normalizado"]=100*(df14T_18 / df14T_18.iloc[0, :])["Adj Close"]
df14T_19["Normalizado"]=100*(df14T_19 / df14T_19.iloc[0, :])["Adj Close"]
df14T_20["Normalizado"]=100*(df14T_20 / df14T_20.iloc[0, :])["Adj Close"]
df14T_21["Normalizado"]=100*(df14T_21 / df14T_21.iloc[0, :])["Adj Close"]
df14T_22["Normalizado"]=100*(df14T_22 / df14T_22.iloc[0, :])["Adj Close"]

# Gráfico 4T

fig = make_subplots(rows = 1, cols = 1,
                    shared_xaxes = True,
                    vertical_spacing = 0.08)

fig.add_trace(go.Scatter(x = df14T_12.index, y = df14T_12["Normalizado"]
                         , name = "2012", line = dict(color = "blue"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df14T_12.index, y = df14T_13["Normalizado"]
                         , name = "2013", line = dict(color = "Red"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df14T_12.index, y = df14T_14["Normalizado"]
                         , name = "2014", line = dict(color = "Orange"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df14T_12.index, y = df14T_15["Normalizado"]
                         , name = "2015", line = dict(color = "Purple"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df14T_12.index, y = df14T_16["Normalizado"]
                         , name = "2016", line = dict(color = "Black"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df14T_12.index, y = df14T_17["Normalizado"]
                         , name = "2017", line = dict(color = "Green"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df14T_12.index, y = df14T_18["Normalizado"]
                         , name = "2018", line = dict(color = "Red"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df14T_12.index, y = df14T_19["Normalizado"]
                         , name = "2019", line = dict(color = "Gray"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df14T_12.index, y = df14T_20["Normalizado"]
                         , name = "2020", line = dict(color = "Dark Blue"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df14T_12.index, y = df14T_21["Normalizado"]
                         , name = "2021", line = dict(color = "Dark Green"))
              , row = 1, col = 1)

fig.add_trace(go.Scatter(x = df14T_12.index, y = df14T_22["Normalizado"]
                         , name = "2022", line = dict(color = "Dark Gray"))
              , row = 1, col = 1)


fig.update_layout(height = 600, width = 600
                  , title_text = "Performance Anual 4T " + ticker1
                  , font_color = "blue"
                  , title_font_color = "black"
                  , xaxis_title = "Meses"
                  , xaxis = dict(tickformat="%m")
                  , yaxis_title = "Fechamento Normalizado"
                  , legend_title = "Anos"
                  , font = dict(size = 15, color = "Black")
                 )
fig.update_layout(hovermode = "x")

fig.show()

